//Diseo y Programacin Orientada al Objeto
//Proyecto Personal - "Agenda del Objeto"
//Nicols Cheker C
//Rol: 9892002-1
//Archivo: tipos.h - Definicin de tipos y clases

#include <stdio.h>

#define FName "agenda.dat"

/****************************************** Estructura de datos de la persona **************************************************/
struct PersonaT
{
  char Apellido [36];                   //35 letras para el apellido + 1 para el caracter nulo
  char Nombre [36];                     //35 letras para el nombre + 1 para el caracter nulo
  char Direccion [41];                  //40 letras para la direccin + 1 para el caracter nulo
  char Ciudad [21];                     //20 letras para la ciudad + 1 para el caracter nulo
  char Telefono [21];                   //20 letras para el telfono + 1 para el caracter nulo
  char Fax [21];                        //20 letras para el fax + 1 para el caracter nulo
  char EMail [51];                      //50 letras para el email + 1 para el caracter nulo
  char Ocupacion [41];                  //40 letras para la ocupacin + 1 para el caracter nulo
};//EndPersonaT

/*********************************************** Definicin de la clase ********************************************************/
class PersonaClass
{

  //Servicios privados
  private:
    long FSize ();                              //Devuelve el tamao del archivo, en registros
    int GetData(int mode);                      //Obtiene datos por consola
    void ShowData();                            //Muestra datos por consola
    int WDataToFile ();                         //Escribe la estructura al archivo, en orden alfabtico
    long RDataFromFile (int SMode, long RegNo, char Ape[36], char Nom[36]); //Lee un dato del arch, por posicin xor por apellido y/o nombre
    void DDataFromFile (long RegNo);            //Borra una estructura del archivo (por n de registro)
    void MDataInFile (long RegNo);              //Modifica un dato existente en el archivo

  public:
    PersonaClass();                             //Constructor
    ~PersonaClass();                            //Destructor
    void MenuGetData ();                        //Men para ingresar nuevos registros
    void MenuListAll ();                        //Men para listar todos los registros
    void MenuListSome ();                       //Men para buscar por nombre y/o apellido
//    void MenuModiReg ();                        //Men para modificar un registro en el arch.

  private:
    struct PersonaT Persona;
    FILE *DataF;
};//EndPersonaClass
